/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

/**
 *
 * @author Molnar Jozsef
 * 
 * Simple model for stroing currency data
 * 4 Properties:
 * - name of the currency (name, Dollar) 
 * - symbol of the currency (symbol, USD)
 * - country of the currency (country, USA)
 * - actual value of the currency in USD
 */
public class CurrencyModel {
    
    public static ObservableList<CurrencyModel> currencyList = FXCollections.observableArrayList();
    
    private SimpleStringProperty currencyCountry = null;
    private SimpleStringProperty currencyName = null;
    private SimpleStringProperty currencySymbol = null;
    private SimpleDoubleProperty currencyValue = null;

    public CurrencyModel(String c,String n,String s,double v) {
        this.currencyCountry = new SimpleStringProperty(c);
        this.currencyName = new SimpleStringProperty(n);
        this.currencySymbol = new SimpleStringProperty(s);
        this.currencyValue = new SimpleDoubleProperty(v);
    }
    
    public void setCurrencyCountry(String c) {
        currencyCountry.set(c);
    }
    
    public void setCurrencyName(String c) {
        currencyName.set(c);
    }
    
    public void setCurrencySymbol(String c) {
        currencySymbol.set(c);
    }
    
    public void setCurrencyValue(double c) {
        currencyValue.set(c);
    }
    
    public String getCurrencyCountry() {
        return currencyCountry.get();
    }
    
    public String getCurrencyName() {
        return currencyName.get();
    }
    
    public SimpleStringProperty getCurrencyCountryProperty() {
        return currencyCountry;
    }

    public String getCurrencySymbol() {
        return currencySymbol.get();
    }
    
    public double getCurrencyValue() {
        return currencyValue.get();
    }
    
    public SimpleStringProperty getCurrencyNameProperty() {
        return currencyName;
    }

    public SimpleStringProperty getCurrencySymbolProperty() {
        return currencySymbol;
    }

    public SimpleDoubleProperty getCurrencyValueProperty() {
        return currencyValue;
    }
}
