/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleStringProperty;

/**
 *
 * @author Molnar Jozsef
 * 
 * Simple model for stock data
 * 3 properties:
 * - name : name of the stock market, concatenated with it's symbol
 * - value: actual value of the stock market
 * - change: change since the last known value
 */
public class StockModel {
    
    private SimpleStringProperty stockName = null;
    private SimpleStringProperty stockChange = null;
    private SimpleDoubleProperty stockNewValue = null;

    public StockModel(String n,double v,String c) {
        this.stockName = new SimpleStringProperty(n);
        this.stockNewValue = new SimpleDoubleProperty(v);
        this.stockChange = new SimpleStringProperty(c);
    }
    
    public SimpleStringProperty getStockNameProperty() {
        return stockName;
    }
    
    public SimpleStringProperty getStockChangeProperty() {
        return stockChange;
    }
    
    public SimpleDoubleProperty getStockNewValueProperty() {
        return stockNewValue;
    }
    
    
    public String getStockName() {
        return stockName.get();
    }

    public void setStockName(SimpleStringProperty stockName) {
        this.stockName = stockName;
    }

    public String getStockChange() {
        return stockChange.get();
    }

    public void setStockChange(SimpleStringProperty stockChange) {
        this.stockChange = stockChange;
    }

    public double getStockNewValue() {
        return stockNewValue.get();
    }

    public void setStockNewValue(SimpleDoubleProperty stockValue) {
        this.stockNewValue = stockValue;
    }    
}
