/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modul;

import java.io.IOException;
import java.util.ListResourceBundle;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.layout.VBox;

/**
 *
 * @author Molnar Jozsef
 * 
 * Modul, consists a single LineChart, which displays the value of the component of the
 * selected stock market.
 * 
 * Name of the selected stock market, and position in the GridPane will be stored.
 * 
 * IMPORTANT: the necessary informations will be given to the controller
 * via a ResourceBundle object - see constructor
 */
public class ChartModul extends VBox {
    
    private String chartStockName;
    private Node view;
    private ObservableList<String> chartCategoryList = FXCollections.observableArrayList();
    private ObservableList<Double> chartValueList = FXCollections.observableArrayList();
    private int x;
    private int y;
    
    public ChartModul(String name,int xx,int yy,ObservableList<String> cats, ObservableList<Double> vals) {
        
        this.chartStockName = name;
        this.chartCategoryList = cats;
        this.chartValueList = vals;
        this.x = xx;
        this.y = yy;
        
        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("chartmodul.fxml"));
        ListResourceBundle lrb = new ListResourceBundle() {

            final Object[][] contents = {
                {"chartStockName", chartStockName },
                {"chartCategoryList", chartCategoryList},
                {"chartValueList", chartValueList}
            };

            @Override
            protected Object[][] getContents() {
                return contents;
            }
        };
        fxmlLoader.setResources(lrb);
        try {
            view = (Node) fxmlLoader.load();
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        getChildren().add(view);
    }

    public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }
}
