/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modul;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.geometry.Side;
import javafx.scene.chart.BarChart;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.LineChart;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.XYChart;

/**
 *
 * @author dodo
 */
public class ChartModulController implements Initializable {

    @FXML
    CategoryAxis stockPaneBarChartX;
    @FXML
    NumberAxis stockPaneBarChartY;
    @FXML
    LineChart<String,Number> stockPaneBarChart;
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        ObservableList<String> category = (ObservableList<String>) rb.getObject("chartCategoryList");
        ObservableList<Double> value    = (ObservableList<Double>) rb.getObject("chartValueList");
        
        XYChart.Series series1 = new XYChart.Series();
        series1.setName("Stock Market for" + rb.getString("chartStockName"));
        stockPaneBarChart.setTitleSide(Side.TOP);
        
        for(int i = 0; i < category.size(); ++i) {
            series1.getData().add(new XYChart.Data(
                        category.get(i),
                        value.get(i).doubleValue()
                    ));
        } 
        stockPaneBarChart.getData().add(series1);
    }
    
}
