/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modul;

import java.net.URL;
import java.util.ArrayList;
import java.util.ResourceBundle;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.chart.BarChart;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.XYChart;
import javafx.scene.control.SplitPane;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.control.cell.TextFieldTableCell;
import javafx.scene.layout.VBox;
import javafx.util.converter.DoubleStringConverter;
import model.CurrencyModel;

/**
 *
 * @author Dodo
 */
public class CurrencyController implements Initializable {
    @FXML
    VBox parentVBox;    
    @FXML
    SplitPane splitPane;
    @FXML
    TableView currencyTable;
    @FXML
    TableColumn currencyCountryColumn,currencyNameColumn,currencySymbolColumn,currencyValueColumn;
    @FXML
    BarChart<String,Number> currencyAllBarChart;
    @FXML
    CategoryAxis currencyAllX;
    @FXML
    NumberAxis currencyAllY;
    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        assert currencyTable != null : "TableView not found";
        assert currencyCountryColumn != null : "TableView not found";
        assert currencyNameColumn != null : "TableView not found";
        assert currencySymbolColumn != null : "TableView not found";
        assert currencyValueColumn != null : "TableView not found";
        
        String currencyURL = dataparsing.MetaData.generateCurrencyDownloadLink();
        ArrayList<String> currencyValues = dataparsing.MetaData.loadHttpFile(currencyURL);
        for(int i = 0; i < currencyValues.size(); ++i) {
            model.CurrencyModel.currencyList.add(
                    new CurrencyModel(dataparsing.MetaData.currencyValues[i][0],
                                      dataparsing.MetaData.currencyValues[i][1],
                                      dataparsing.MetaData.currencyValues[i][3],
                                      Double.valueOf(currencyValues.get(i).split(",")[1]))
            );
        }
        
        currencyCountryColumn.setCellValueFactory(new PropertyValueFactory<model.CurrencyModel,String>("currencyCountry"));
        currencyNameColumn.setCellValueFactory(new PropertyValueFactory<model.CurrencyModel,String>("currencyName"));
        currencySymbolColumn.setCellValueFactory(new PropertyValueFactory<model.CurrencyModel,String>("currencySymbol"));
        currencyValueColumn.setCellValueFactory(new PropertyValueFactory<model.CurrencyModel,Double>("currencyValue"));
        currencyValueColumn.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
        
        currencyCountryColumn.prefWidthProperty().bind(currencyTable.widthProperty().divide(4)); // w * 1/4
        currencyNameColumn.prefWidthProperty().bind(currencyTable.widthProperty().divide(4)); // w * 1/4
        currencySymbolColumn.prefWidthProperty().bind(currencyTable.widthProperty().divide(4)); // w * 1/4
        currencyValueColumn.prefWidthProperty().bind(currencyTable.widthProperty().divide(4)); // w * 1/4
        
        currencyTable.setItems(model.CurrencyModel.currencyList);
        
        XYChart.Series series1 = new XYChart.Series();
        series1.setName("Currency prices in $");
        for(int i = 0; i < model.CurrencyModel.currencyList.size(); ++i) {
            series1.getData().add(new XYChart.Data(
                        model.CurrencyModel.currencyList.get(i).getCurrencySymbol(),
                        model.CurrencyModel.currencyList.get(i).getCurrencyValue()
                    ));
        }
        currencyAllBarChart.getData().add(series1);
    }
    
}
