/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modul;

import au.com.bytecode.opencsv.CSVReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.geometry.Side;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.LineChart;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.XYChart;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.control.cell.TextFieldTableCell;
import javafx.scene.layout.AnchorPane;
import javafx.util.converter.DoubleStringConverter;
import javafx.util.converter.LongStringConverter;

/**
 *
 * @author dodo
 */
public class HistoryController implements Initializable {

    @FXML
    static TextField textFieldStockName, textFieldFrom, textFieldTo;
    @FXML
    static Button buttonShow;
    @FXML
    static TableColumn tableColumnDate, tableColumnOpen, tableColumnHigh, tableColumnLow, tableColumnClose, tableColumnVolume, tableColumnAdjClose;
    @FXML
    static TableView tableHistory;
    @FXML
    static ComboBox comboboxInterval;
    @FXML
    static CategoryAxis axisDate;
    @FXML
    static NumberAxis axisValue;
    @FXML
    static LineChart<String, Number> chartHistory;
    @FXML
    static AnchorPane parentPane;

    @Override
    public void initialize(URL url, ResourceBundle rb) {

        tableColumnDate.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, String>("stockDate"));
        tableColumnOpen.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, Double>("stockOpen"));
        tableColumnHigh.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, Double>("stockHigh"));
        tableColumnLow.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, Double>("stockLow"));
        tableColumnClose.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, Double>("stockClose"));
        tableColumnAdjClose.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, Double>("stockAdjClose"));
        tableColumnVolume.setCellValueFactory(new PropertyValueFactory<model.HistoryQuoteModul, Long>("stockVolume"));

        tableColumnOpen.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
        tableColumnHigh.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
        tableColumnLow.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
        tableColumnClose.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
        tableColumnAdjClose.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
        tableColumnVolume.setCellFactory(TextFieldTableCell.forTableColumn(new LongStringConverter()));

        tableColumnDate.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnOpen.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnHigh.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnDate.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnLow.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnClose.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnAdjClose.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));
        tableColumnVolume.prefWidthProperty().bind(tableHistory.widthProperty().divide(7));

        parentPane.prefWidthProperty().bind(stockview2013.stockdisplayController.tabHistoryAnchorPane.widthProperty());
        parentPane.prefHeightProperty().bind(stockview2013.stockdisplayController.tabHistoryAnchorPane.heightProperty());

        buttonShow.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent t) {

                model.HistoryQuoteModul.stockHistoryList.clear();
                chartHistory.getData().clear();
                try {
                    String stockName = textFieldStockName.getText();
                    String stockFrom = textFieldFrom.getText();
                    String stockTo = textFieldTo.getText();
                    String interval = (String) comboboxInterval.getValue();
                    char c_interval;
                    if (interval.equals("Day")) {
                        c_interval = 'd';
                    } else if (interval.equals("Month")) {
                        c_interval = 'm';
                    } else if (interval.equals("Week")) {
                        c_interval = 'w';
                    } else {
                        stockview2013.stockdisplayController.setStatusMessage("Please choose a period!");
                        return;
                    }
                    if ((stockName == null) || (stockFrom == null) || (stockTo == null)) {
                        stockview2013.stockdisplayController.setStatusMessage("Invalid stock name, from or to date!");
                        return;
                    }
                    /*if(stockName.startsWith("^")) {
                        stockName = "%40%5E" + stockName.substring(1);
                    }*/
                    URL stockUrl = new URL("http://ichart.yahoo.com/table.csv?s="
                            + stockName
                            + "&a=" + (Integer.valueOf(stockFrom.split("-")[1]) - 1)
                            + "&b=" + stockFrom.split("-")[2]
                            + "&c=" + stockFrom.split("-")[0]
                            + "&d=" + (Integer.valueOf(stockTo.split("-")[1]) - 1)
                            + "&e=" + stockTo.split("-")[2]
                            + "&f=" + stockTo.split("-")[0]
                            + "&g=" + c_interval
                            + "&ignore=.csv");
                    System.out.println(stockUrl.getPath());
                    loadHistoricalData(stockName, stockUrl);
                    
                } catch (MalformedURLException ex) {
                    Logger.getLogger(HistoryController.class.getName()).log(Level.SEVERE, null, ex);
                    stockview2013.stockdisplayController.setStatusMessage("Invalid URL! Please check the input values!");
                } catch (IOException ex) {
                    stockview2013.stockdisplayController.setStatusMessage("Error downloading the stock data!");
                    Logger.getLogger(HistoryController.class.getName()).log(Level.SEVERE, null, ex);
                } catch (Exception e) {
                    stockview2013.stockdisplayController.setStatusMessage("An error occured, please check the input values!");
                }

            }
        });
    }

    public static void loadHistoricalData(String stockName, URL url) {
        try {
            CSVReader reader = null;
            try {
                reader = new CSVReader(new InputStreamReader(url.openConnection().getInputStream()));
            }catch (NullPointerException e) {
                stockview2013.stockdisplayController.setStatusMessage("Stock doesnt exists or FROM date is greater than TO date!");
            }
            String[] nextLine;
            reader.readNext();
            while ((nextLine = reader.readNext()) != null) {
                if (nextLine.length != 7) {
                    continue;
                } else {
                    model.HistoryQuoteModul.stockHistoryList.add(
                            new model.HistoryQuoteModul(
                            nextLine[0],
                            Double.valueOf(nextLine[1]),
                            Double.valueOf(nextLine[2]),
                            Double.valueOf(nextLine[3]),
                            Double.valueOf(nextLine[4]),
                            Long.valueOf(nextLine[5]),
                            Double.valueOf(nextLine[6])));
                }
            }

            XYChart.Series series1 = new XYChart.Series();
            series1.setName("Historical Quotes for: " + stockName);
            chartHistory.setTitleSide(Side.TOP);

            for (int i = 0; i < model.HistoryQuoteModul.stockHistoryList.size(); ++i) {
                series1.getData().add(new XYChart.Data(
                        model.HistoryQuoteModul.stockHistoryList.get(i).getStockDate(),
                        model.HistoryQuoteModul.stockHistoryList.get(i).getStockClose()));
            }
            chartHistory.getData().add(series1);
            tableHistory.setItems(model.HistoryQuoteModul.stockHistoryList);

            servercommunication.HttpClient.sendRequestedData(stockName, servercommunication.HttpClient.HISTORY_REQUEST);
        } catch (IOException ex) {
            Logger.getLogger(HistoryController.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
