/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modul;

import au.com.bytecode.opencsv.CSVReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.control.cell.TextFieldTableCell;
import javafx.util.converter.DoubleStringConverter;
import model.StockModel;

/**
 *
 * @author dodo
 */
public class StockTableController implements Initializable {

    @FXML
    TableView stockTable;
    @FXML
    TableColumn stockNameColumn,stockNewValueColumn,stockChangeColumn;
    @FXML
    Label stockMarketLabel;
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        try {
            assert stockTable != null : "TableView not found";
            assert stockNameColumn != null : "TableView not found";
            assert stockNewValueColumn != null : "TableView not found";
            assert stockChangeColumn != null : "TableView not found";
            
            String stockUrlString = rb.getString("stockName");
            stockMarketLabel.setText(rb.getString("stockSymbol") + " stock market:");
            ObservableList<StockModel> stockList = (ObservableList<StockModel>) rb.getObject("stockList");
            URL stockUrl = new URL(stockUrlString);
            CSVReader reader = new CSVReader(new InputStreamReader(stockUrl.openConnection().getInputStream()));
            String [] nextLine;
            while ((nextLine = reader.readNext()) != null) {
                if(nextLine.length != 4) { continue; }
                try {
                    if(nextLine[2].equals("N/A") || nextLine[3].equals("N/A") || nextLine[2] == null || nextLine[3] == null) {
                        continue;
                    }
                    stockList.add(new model.StockModel(
                                        nextLine[0] + " :" + nextLine[1],
                                        Double.valueOf(nextLine[2]),
                                        String.format("%.3f",((Double.valueOf(nextLine[3]) - (Double.valueOf(nextLine[2]))) / (Double.valueOf(nextLine[3]))) * 100) + "%"
                        ));
                } catch (Exception e) {
                    Logger.getLogger(StockTableController.class.getName()).log(Level.SEVERE, null, e);
                    Logger.getGlobal().log(Level.OFF, "Invalid input value for a give Stock");
                    Logger.getGlobal().log(Level.OFF, "Stock value will not appear in the table");
                    continue;
                }
            }

            stockNameColumn.setCellValueFactory(new PropertyValueFactory<model.StockModel,String>("stockName"));
            stockNewValueColumn.setCellValueFactory(new PropertyValueFactory<model.StockModel,Double>("stockNewValue"));
            stockChangeColumn.setCellValueFactory(new PropertyValueFactory<model.StockModel,String>("stockChange"));
            stockNewValueColumn.setCellFactory(TextFieldTableCell.forTableColumn(new DoubleStringConverter()));
            
            stockNameColumn.prefWidthProperty().bind(stockTable.widthProperty().divide(2)); // w * 1/2
            stockNewValueColumn.prefWidthProperty().bind(stockTable.widthProperty().divide(4)); // w * 1/4
            stockChangeColumn.prefWidthProperty().bind(stockTable.widthProperty().divide(4)); // w * 1/4
            
            stockTable.setItems(stockList);
        } catch (MalformedURLException ex) {
            Logger.getLogger(StockTableController.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(StockTableController.class.getName()).log(Level.SEVERE, null, ex);
        } 
    }
    
}
