/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modul;

import java.io.IOException;
import java.util.ListResourceBundle;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.layout.VBox;
import model.StockModel;

/**
 *
 * @author dodo
 */
public class StockTableModul extends VBox{
    
    private Node view;
    private String stockName;
    private String stockSymbol;
    private ObservableList<StockModel> stockList = FXCollections.observableArrayList();
    private int x;
    private int y;
    
    public StockTableModul(String name,int xx,int yy) {
        x = xx;
        y = yy;
        stockSymbol = name;
        if(name.startsWith("^")) {
            this.stockName = "%40%5E" + name.substring(1);
        } else {
            this.stockName = name;
        }
        
        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("stockTableModul.fxml"));
        ListResourceBundle lrb = new ListResourceBundle() {

            final Object[][] contents = {
                {"stockName", dataparsing.MetaData.getStockDownloadLink(stockName) },
                {"stockList", stockList},
                {"stockSymbol", stockSymbol}
            };

            @Override
            protected Object[][] getContents() {
                return contents;
            }
        };
        fxmlLoader.setResources(lrb);
        try {
            view = (Node) fxmlLoader.load();
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        getChildren().add(view);
    }
    
    public String getStockName() {
        return this.stockName;
    }
    
    public ObservableList<StockModel> getList() {
        return this.stockList;
    }
    
    public ObservableList<String> getStockNames() {
        ObservableList<String> list = FXCollections.observableArrayList();
        for(StockModel s : stockList) {
            list.add(s.getStockName().split(":")[1]);
        }
        return list;
    }
    
    public ObservableList<Double> getStockValues() {
        ObservableList<Double> list = FXCollections.observableArrayList();
        for(StockModel s : stockList) {
            list.add(s.getStockNewValue());
        }
        return list;
    }
 
    public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }
}
