/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package servercommunication;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CookieStore;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.protocol.ClientContext;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.PoolingClientConnectionManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpContext;
import org.apache.http.protocol.HttpContext;

/**
 *
 * @author dodo
 */
public class HttpClient {

    public static int statusCode = 400;
    public static String username = null;
    /**
     * Creates a thread-safe HttpClient
     *
     * @return an DefaultHttpClient instance
     */
    public static DefaultHttpClient getThreadSafeClient() {

        DefaultHttpClient client = new DefaultHttpClient();
        ClientConnectionManager mgr = client.getConnectionManager();
        HttpParams params = client.getParams();
        client = new DefaultHttpClient(new PoolingClientConnectionManager(
                mgr.getSchemeRegistry()));
        return client;
    }
    static DefaultHttpClient httpclient = getThreadSafeClient();
    static CookieStore cookieStore = new BasicCookieStore();
    static HttpContext httpContext = new BasicHttpContext();
    public static int DATA_REQUEST = 0;
    public static int CHART_REQUEST = 1;
    public static int HISTORY_REQUEST = 2;
    static final String LOGON_SITE = "http://localhost:8080/StockMaven/desktop/login";
    static final int LOGON_PORT = 8080;

    public static int logInHttpPost(String usr, String pwd) throws Exception {
        httpContext.setAttribute(ClientContext.COOKIE_STORE, cookieStore);
        username = usr;
        HttpPost httpPost = new HttpPost(LOGON_SITE);
        try {
            httpclient.getCredentialsProvider().setCredentials(
                    new AuthScope("localhost", LOGON_PORT),
                    new UsernamePasswordCredentials(usr, pwd));
            httpclient.getCookieStore().clear();
            HttpResponse response = httpclient.execute(httpPost);
            
            List<Cookie> list = httpclient.getCookieStore().getCookies();
            for (Cookie c : list) {
                System.out.println(c);
            }
            return response.getStatusLine().getStatusCode();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            httpPost.releaseConnection();
        }

        return 0;
    }

    public static void sendRequestedData(String name, int type) {
        HttpPost post = new HttpPost("http://localhost:8080/StockMaven/desktop/stock");
        try {     
            List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(1);
            nameValuePairs.add(new BasicNameValuePair("stockname", name));
            nameValuePairs.add(new BasicNameValuePair("type", String.valueOf(type)));
            post.setEntity(new UrlEncodedFormEntity(nameValuePairs));
            HttpResponse response = httpclient.execute(post);
        } catch (UnsupportedEncodingException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            post.releaseConnection();
        }
    }

    public static Map<String, String> getInitData() {
        HttpPost post = new HttpPost("http://localhost:8080/StockMaven/desktop/init");
        HashMap map = new HashMap<String, String>();
        try {
            HttpResponse response = httpclient.execute(post);
            for (Cookie c : httpclient.getCookieStore().getCookies()) {
                map.put(c.getName(), c.getValue());
            }

        } catch (UnsupportedEncodingException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            post.releaseConnection();
            return map;
        }
    }
    
    public static ArrayList<String> getMessages() {
        HttpPost post = new HttpPost("http://localhost:8080/StockMaven/desktop/messages");
        ArrayList<String> list = new ArrayList<>();
        try {
            httpclient.getCookieStore().clear();
            HttpResponse response = httpclient.execute(post);
            for (Cookie c : httpclient.getCookieStore().getCookies()) {
                list.add(c.getValue());
            }

        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            post.releaseConnection();
            return list;
        }
    }
    
    public static void sendMessage(String to, String title, String msg) {
        HttpPost post = new HttpPost("http://localhost:8080/StockMaven/message/add");
        try {     
            List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
            nameValuePairs.add(new BasicNameValuePair("from", username));
            nameValuePairs.add(new BasicNameValuePair("to", to));
            nameValuePairs.add(new BasicNameValuePair("title", title));
            nameValuePairs.add(new BasicNameValuePair("msg", msg));
            post.setEntity(new UrlEncodedFormEntity(nameValuePairs));
            httpclient.getCookieStore().clear();
            HttpResponse response = httpclient.execute(post);
            System.out.println(response.getStatusLine());
            for (Cookie c : httpclient.getCookieStore().getCookies()) {
                System.out.println(c.getValue());
            }
        } catch (UnsupportedEncodingException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            post.releaseConnection();
        }
    }

    public static void shutDownHttpClient() {
        httpclient.getConnectionManager().shutdown();
    }

    public static int getStatusCode() {
        return statusCode;
    }
}
