/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stockview2013;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Hashtable;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.TreeSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.control.MenuItem;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.Separator;
import javafx.scene.control.TabPane;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import modul.ChartModul;
import modul.HistoryModul;
import modul.StockTableModul;

/**
 *
 * @author Molnar Jozsef
 *
 *
 * This is the main controller of the application. Handles the Menu events, and
 * initializes the main window.
 */
public class stockdisplayController implements Initializable {

    private static Hashtable<String, StockTableModul> selectedStocks = new Hashtable<String, StockTableModul>();
    private static Hashtable<String, ChartModul> selectedCharts = new Hashtable<String, ChartModul>();
    private static TreeSet<String> loadedTables = new TreeSet<String>();
    private int numberOfNodes = 2;
    private static boolean[][] gridPlaces = new boolean[10][2];
    private int gridCapacity = gridPlaces.length * gridPlaces[0].length;
    private int actualRowX = 0;
    private int actualRowY = 0;
    private boolean indexAfterRemove = false;
    private static login.LoginDialog loginDialog = login.LoginDialog.getLoginDialog();
    private static ArrayList<String> messages = null;
    private static int messagesIndex = 0;
    @FXML
    static StackPane stackPane;
    @FXML
    static TabPane contentTabPane;
    @FXML
    AnchorPane tabCurrencyAnchorPane, tabStockAnchorPane, tabMessagingAnchorPane;
    @FXML
    public static AnchorPane tabHistoryAnchorPane;
    @FXML
    VBox stockVBox;
    @FXML
    ScrollPane stockScrollPane;
    @FXML
    GridPane currencyTabPane;
    @FXML
    static GridPane stockTabPane;
    @FXML
    MenuItem menuItemClose;
    @FXML
    Button stockPaneTableAddButton, stockPaneChartAddButton, stockPaneTableRemoveButton, stockPaneChartRemoveButton;
    @FXML
    ComboBox stockTableComboBox, stockChartComboBox;
    @FXML
    static Label statusBar;
    @FXML
    static TextField messageFromField, messageDateField, messageToField, messageToTitleField, messageTitleField;
    @FXML
    static TextArea messageTextField, messageBodyField;
    @FXML
    Button messageSendButton, messagePrevButton, messageNextButton;

    @Override
    public void initialize(URL url, ResourceBundle rb) {

        assert currencyTabPane != null : "Currency Tab not found";
        currencyTabPane.add(new modul.CurrencyModul(), 0, 0);
        tabHistoryAnchorPane.getChildren().add(new HistoryModul());
        //selectedStocks.put("^FTPE", new modul.StockTableModul("^FTPE"));
        //selectedStocks.put("^BFX", new modul.StockTableModul("^BFX"));
        //selectedStocks.put("^ATX", new modul.StockTableModul("^ATX"));
        //selectedStocks.put("^MXX", new modul.StockTableModul("^MXX"));

        for (int i = 0; i < gridPlaces.length; ++i) {
            for (int j = 0; j < gridPlaces[i].length; ++j) {
                gridPlaces[i][j] = false;
            }
        }
        //stockTabPane.add(selectedStocks.get("^FTPE"),0,1);
        //stockTabPane.add(selectedStocks.get("^ATX"),1,0);
        //stockTabPane.add(selectedStocks.get("^MXX"),1,1);
        //stockTabPane.getRowConstraints().add(new RowConstraints(280));
        //stockTabPane.add(selectedStocks.get("^BFX"),1,2);
        stockTabPane.setGridLinesVisible(true);

        initComboBoxes();

        stockPaneTableAddButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                String selectedStockMarket = (String) stockTableComboBox.getValue();
                if (selectedStockMarket == null) {
                    return;
                }
                if (loadedTables.contains(selectedStockMarket)) {
                    return;
                } else {
                    if (!selectedStocks.containsKey(selectedStockMarket)) {
                        loadStockData(selectedStockMarket);
                    }
                    if (indexAfterRemove) {
                        searchForGridPlace();
                        indexAfterRemove = false;
                    } else {
                        countGridPlaces();
                    }
                    selectedStocks.get(selectedStockMarket).setX(actualRowX);
                    selectedStocks.get(selectedStockMarket).setY(actualRowY);
                    loadedTables.add(selectedStockMarket);
                    stockTabPane.add(selectedStocks.get(selectedStockMarket),
                            actualRowX,
                            actualRowY);

                    servercommunication.HttpClient.sendRequestedData(selectedStockMarket, servercommunication.HttpClient.DATA_REQUEST);
                }
            }
        });

        stockPaneTableRemoveButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                String selectedStockMarket = (String) stockTableComboBox.getValue();
                if (selectedStockMarket == null) {
                    return;
                }
                loadedTables.remove(selectedStockMarket);
                removeGridPlace(selectedStocks.get(selectedStockMarket).getX(),
                        selectedStocks.get(selectedStockMarket).getY());
                stockTabPane.getChildren().remove(selectedStocks.get(selectedStockMarket));
            }
        });

        stockPaneChartAddButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                String selectedStockMarket = (String) stockChartComboBox.getValue();
                if (selectedStockMarket == null) {
                    return;
                }
                if (selectedCharts.containsKey(selectedStockMarket)) {
                    return;
                }
                loadStockData(selectedStockMarket);
                if (indexAfterRemove) {
                    searchForGridPlace();
                    indexAfterRemove = false;
                } else {
                    countGridPlaces();
                }
                selectedCharts.put(selectedStockMarket, new modul.ChartModul(selectedStockMarket,
                        actualRowX,
                        actualRowY,
                        selectedStocks.get(selectedStockMarket).getStockNames(),
                        selectedStocks.get(selectedStockMarket).getStockValues()));
                stockTabPane.add(selectedCharts.get(selectedStockMarket),
                        selectedCharts.get(selectedStockMarket).getX(),
                        selectedCharts.get(selectedStockMarket).getY());

                servercommunication.HttpClient.sendRequestedData(selectedStockMarket, servercommunication.HttpClient.CHART_REQUEST);
            }
        });

        stockPaneChartRemoveButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                String selectedStockMarket = (String) stockChartComboBox.getValue();
                if (selectedStockMarket == null) {
                    return;
                }
                stockTabPane.getChildren().remove(selectedCharts.get(selectedStockMarket));
                removeGridPlace(selectedCharts.get(selectedStockMarket).getX(),
                        selectedCharts.get(selectedStockMarket).getY());
                selectedCharts.remove(selectedStockMarket);
            }
        });

        menuItemClose.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent t) {
                servercommunication.HttpClient.shutDownHttpClient();
                System.exit(0);
            }
        });

        messageNextButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                messagesIndex++;
                if (messagesIndex == messages.size()) {
                    messagesIndex = messages.size() - 1;
                    return;
                }
                String[] first = messages.get(messagesIndex).split(";");
                if (first.length != 4) {
                    messagesIndex--;
                    return;
                }
                messageFromField.setText(first[0]);
                messageDateField.setText(first[1]);
                messageTitleField.setText(first[2]);
                messageTextField.setText(first[3]);
            }
        });

        messagePrevButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                messagesIndex--;
                if (messagesIndex < 0) {
                    messagesIndex = 0;
                    return;
                }
                String[] first = messages.get(messagesIndex).split(";");
                if (first.length != 4) {
                    messagesIndex++;
                    return;
                }
                messageFromField.setText(first[0]);
                messageDateField.setText(first[1]);
                messageTitleField.setText(first[2]);
                messageTextField.setText(first[3]);
            }
        });
        
        messageSendButton.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent t) {
                String to = messageToField.getText();
                String title = messageToTitleField.getText();
                String msg = messageBodyField.getText();
                servercommunication.HttpClient.sendMessage(to, title, msg);
            }
        });

        stockVBox.prefHeightProperty().bind(contentTabPane.heightProperty()); // w * 1/1
        stockVBox.prefWidthProperty().bind(contentTabPane.widthProperty()); // w * 1/1
        stockTabPane.prefWidthProperty().bind(contentTabPane.widthProperty()); // w * 1/1
        stockTabPane.prefHeightProperty().bind(contentTabPane.heightProperty()); // w * 1/1
        currencyTabPane.prefWidthProperty().bind(contentTabPane.widthProperty()); // w * 1/1
        currencyTabPane.prefHeightProperty().bind(contentTabPane.heightProperty()); // w * 1/1
        statusBar.prefWidthProperty().bind(contentTabPane.widthProperty());
        contentTabPane.setVisible(false);
        stackPane.getChildren().add(stockdisplayController.loginDialog);
    }

    /**
     * Sets the static content of the ComboBoxes
     */
    public void initComboBoxes() {
        stockTableComboBox.getItems().add(new Separator());
        stockTableComboBox.getItems().add("America");
        stockTableComboBox.getItems().add(new Separator());
        stockChartComboBox.getItems().add(new Separator());
        stockChartComboBox.getItems().add("America");
        stockChartComboBox.getItems().add(new Separator());
        for (String s : dataparsing.MetaData.stockMarketsAmerica) {
            stockTableComboBox.getItems().add(s);
            stockChartComboBox.getItems().add(s);
        }

        stockTableComboBox.getItems().add(new Separator());
        stockTableComboBox.getItems().add("Asia/Pacific");
        stockTableComboBox.getItems().add(new Separator());
        stockChartComboBox.getItems().add(new Separator());
        stockChartComboBox.getItems().add("Asia/Pacific");
        stockChartComboBox.getItems().add(new Separator());
        for (String s : dataparsing.MetaData.stockMarketsAsiaPacific) {
            stockTableComboBox.getItems().add(s);
            stockChartComboBox.getItems().add(s);
        }

        stockTableComboBox.getItems().add(new Separator());
        stockTableComboBox.getItems().add("Europa");
        stockTableComboBox.getItems().add(new Separator());
        stockChartComboBox.getItems().add(new Separator());
        stockChartComboBox.getItems().add("Europa");
        stockChartComboBox.getItems().add(new Separator());
        for (String s : dataparsing.MetaData.stockMarketsEuropa) {
            stockTableComboBox.getItems().add(s);
            stockChartComboBox.getItems().add(s);
        }
    }

    /**
     * Downloads and puts the data for the given stock market into the
     * <code>selectedStockMarket</code> hashtable
     *
     * @param selectedStockMarket The name of the stock market
     */
    public void loadStockData(String selectedStockMarket) {
        String key = null;
        if (selectedStockMarket.equals("America") || selectedStockMarket.equals("Asia/Pacific") || selectedStockMarket.equals("Europa")) {
            key = dataparsing.MetaData.generateContinentStockMarketName(selectedStockMarket);
        } else {
            key = selectedStockMarket;
        }
        selectedStocks.put(selectedStockMarket, new modul.StockTableModul(key, 0, 0));
    }

    /**
     * Sets the
     * <code>actualRowX</code> and
     * <code>actualRowY</code> variables according to the number of moduls in
     * the gridpane
     */
    public void countGridPlaces() {
        numberOfNodes++;
        actualRowX = (numberOfNodes - 1) % 2;
        actualRowY = (numberOfNodes - 1) / 2;
        gridPlaces[actualRowY][actualRowX] = true;
    }

    /**
     * Deletes the given Modul from the GridPane controll variables
     *
     * @param row
     * @param column
     */
    public void removeGridPlace(int x, int y) {
        gridPlaces[y][x] = false;
        indexAfterRemove = true;
        numberOfNodes--;
    }

    /**
     * Searches the first available place in the GridPane, and sets the
     * <code>actualRowX</code> and
     * <code>actualRowY</code> variables
     */
    public void searchForGridPlace() {
        numberOfNodes++;
        for (int i = 0; i < gridPlaces.length; ++i) {
            for (int j = 0; j < gridPlaces[i].length; ++j) {
                if (!gridPlaces[i][j]) {
                    actualRowX = j;
                    actualRowY = i;
                    System.out.println(i + " " + j);
                    return;
                }
            }
        }
    }

    public static void logInSuccesful() {
        contentTabPane.setVisible(true);
        stackPane.getChildren().remove(loginDialog);

        Map<String, String> maxMap = servercommunication.HttpClient.getInitData();

        if (maxMap.get("maxTable") != null) {
            selectedStocks.put(maxMap.get("maxTable"), new modul.StockTableModul(maxMap.get("maxTable"), 0, 0));
            stockTabPane.add(selectedStocks.get(maxMap.get("maxTable")), 0, 0);
            loadedTables.add(maxMap.get("maxTable"));
            gridPlaces[0][0] = true;
        }

        if (maxMap.get("maxChart") != null) {
            selectedStocks.put(maxMap.get("maxChart"), new modul.StockTableModul(maxMap.get("maxChart"), 1, 0));
            selectedCharts.put(maxMap.get("maxChart"), new modul.ChartModul(maxMap.get("maxChart"),
                    1,
                    0,
                    selectedStocks.get(maxMap.get("maxChart")).getStockNames(),
                    selectedStocks.get(maxMap.get("maxChart")).getStockValues()));
            stockTabPane.add(selectedCharts.get(maxMap.get("maxChart")), 1, 0);
            gridPlaces[1][0] = true;
        }
        try {
            Calendar cal = Calendar.getInstance();
            String stockName = maxMap.get("maxHistory");
            if (stockName != null) {
                /*if (stockName.startsWith("^")) {
                 stockName = "%40%5E" + stockName.substring(1);
                 } */
                URL stockUrl = new URL("http://ichart.yahoo.com/table.csv?s="
                        + stockName
                        + "&a=" + (cal.getTime().getMonth() - 1)
                        + "&b=" + cal.getTime().getDay()
                        + "&c=" + cal.getTime().getYear()
                        + "&d=" + (cal.getTime().getMonth() - 4)
                        + "&e=" + cal.getTime().getDay()
                        + "&f=" + cal.getTime().getYear()
                        + "&g=w"
                        + "&ignore=.csv");
                modul.HistoryController.loadHistoricalData(stockName, stockUrl);
            }
        } catch (MalformedURLException ex) {
            Logger.getLogger(stockdisplayController.class.getName()).log(Level.SEVERE, null, ex);
        } catch (Exception e) {
            setStatusMessage("Invalid stock name, or date: download failed.");
        }

        messages = servercommunication.HttpClient.getMessages();
        String[] first = null;
        if (!messages.isEmpty()) {
            first = messages.get(0).split(";");
            if (first.length != 4) {
                return;
            }
            messageFromField.setText(first[0]);
            messageDateField.setText(first[1]);
            messageTitleField.setText(first[2]);
            messageTextField.setText(first[3]);
        }

    }

    public static void setStatusMessage(String msg) {
        statusBar.setText(msg);
    }
}
